%circleF

%%% REQUIRED %%%
% radius % circle radius.
%%% OPTIONAL %%%
% matrixWidith % matrix width (columns). if not specified will default to 4 x radius.
% matrixHight % matrix hight (rows). if not specified will default to 4 x radius.
% originX % circle origin/centre x co-ordinate (column index). if not specified will default to matrix centre. 
% originY % circle origin/centre y co-ordinate (row index). if not specified will default to matrix centre. 


function Circle = circleF(radius,matrixWidth,matrixHight,originX,originY)
%%% ARGUMENT SORTER %%%
if nargin == 1
    width = radius*4;
elseif nargin > 1
    width = matrixWidth;
else
    disp('require at least a radius argument to work!')
end

if rem(width,2) == 0 && nargin < 5
    width = width + 1;
    if nargin > 1
        disp('matrix hight and width must be odd unless you specify an origin, therfore the dimensions have been increased by 1 to make odd. This is because the default origin is the matrix centre')
    end
end

if nargin < 3
    hight = width;
elseif nargin >= 3
    hight = matrixHight;
end

if nargin < 5
    if rem(hight,2) == 0 
        hight = hight + 1;
        disp('matrix hight and width must be odd unless you specify an origin, therfore the dimensions have been increased by 1 to make odd. This is because the default origin is the matrix centre')
    end
    X = ceil(width/2);
    Y = ceil(hight/2);
elseif nargin == 5
    X = originX;
    Y = originY;
end
%%% ARGUMENT SORTER END %%%        
img1 = zeros(hight,width);

centerX = X;
centerY = Y;

for row = 1:hight
    for col = 1:width
        if (((row - centerY)^2) + ((col - centerX)^2)) <= (radius^2)
            img1(row,col) = 1;
        end
    end
end

Circle = img1;
        
  
%   % Create a logical image of a circle with specified
% % diameter, center, and image size.
% % First create the image.
% imageSizeX = 640;
% imageSizeY = 480;
% [columnsInImage rowsInImage] = meshgrid(1:imageSizeX, 1:imageSizeY);
% % Next create the circle in the image.
% centerX = 320;
% centerY = 240;
% radius = 100;
% circlePixels = (rowsInImage - centerY).^2 ...
%     + (columnsInImage - centerX).^2 <= radius.^2;
% % circlePixels is a 2D "logical" array.
% % Now, display it.
% image(circlePixels) ;
% colormap([0 0 0; 1 1 1]);
% title('Binary image of a circle');
%   2 Comments