% getGrayscale()
%
% greyImage = getGrayscale(input, index)
%
% <><><> Required Functions <><><> %
% > getTopImgX()
%
% ======= INPUT ======= %
% ------- Required ------- %
% Input: -Any image file, folder or matrix.
% ------- Optional ------- %
% Index: -integer repesenting the image file in the folder (if using folder)
%
% ======= OUTPUT ======= %
% greyImage: -intensity image matrix.
%

function greyImage = getGrayscale(input, index)

% Default

idx = 1;

if nargin > 1
    idx = index;
end

if isnumeric(input) == 1
    image0 = input;
elseif length(dir(fullfile(input))) == 1
    image0 = imread(imageA);
elseif length(dir(fullfile(input))) > 1
    image0 = getTopImgX(input,idx);
end
    
if size(image0,3)==3
    image0 = rgb2gray(image0);
end

greyImage = image0;
    
end