% ratePurgeV3
% traces = cell array, where each cell contains a matrix with the 5 columns
% (x,y,frame,Idx,time).

function [purgedPosList,originalTracesWithVelocitys,purgedTraceList,purgedRawList] = ratePurgeV3(traceList,posList,lowLim,highLm)
if nargin < 4
    highLim = 999;
elseif nargin == 4
    highLim = highLm;
end
traces = traceList;
n = numel(traces(:,1));
badTraces = zeros(n,1); % what is this used for?
dex = 0;
dexLa = 1;
dexLb = 0;
posyList = posList;
posyList(end,6)=0;
badPosIdx = zeros(length(posList),1);
for k=1:n;
    totTime = traces{k,1}(end,5) - traces{k,1}(1,5);
    deltaX = abs(traces{k,1}(2:end,1) - traces{k,1}(1:(end-1),1));
    deltaY = abs(traces{k,1}(2:end,2) - traces{k,1}(1:(end-1),2));
    deltaXY = sqrt(deltaX.^2 + deltaY.^2);
    deltaXYsum = sum(deltaXY);
    velocity = deltaXYsum/totTime;
    traces{k,2} = velocity;
    if velocity < lowLim || highLim < velocity
        dex = dex + 1;
        dexLb = dexLa + length(traces{k,1}(:,4)) - 1;
        badTraces(dex) = k; % what is this used for?
        badPosIdx(dexLa:dexLb,1) = traces{k,1}(:,4);
        dexLa = dexLb+1;
    end
end
disp('start badPosIdx length: ');disp(length(badPosIdx));
badPosIdx = badPosIdx(badPosIdx ~= 0);
disp('end badPosIdx length: ');disp(length(badPosIdx));
posid(:,1) = posyList(:,4);
fullPosList = zeros(max(posid(:)),6);
fullPosList(posid,:) = posyList(:,:);
fullPosList(badPosIdx,6) = 1;
neatPosList = fullPosList(fullPosList(:,4) ~= 0,:);

purgedPosList = posList(neatPosList(:,6) ~= 1,:);

tracesVarray = cell2mat(traces(:,2));
purgedTraceList = traces(tracesVarray(:) > lowLim & tracesVarray(:) < highLim,:);
lengthL = 0;
numOfTraces = numel(purgedTraceList(:,1));
for pTa = 1:numOfTraces
    lengthL= lengthL+length(purgedTraceList{pTa}(:,1));
end 
nwRawList = zeros(lengthL,6);
stID = 1;
for pTb = 1:numOfTraces
    edID = (stID-1) + length(purgedTraceList{pTb}(:,1));
    nwRawList(stID:edID,1:5) = purgedTraceList{pTb}(:,:);
    nwRawList(stID:edID,6) = pTb;
    stID = edID + 1;
end
purgedRawList = nwRawList; % "raw" tracked possition array after purge. columns: |x|y|frame number|position index|time|trace index|.
originalTracesWithVelocitys = traces;
purgedPosList = purgedPosList;